%def_enable threads
%def_enable smp
%def_enable kernel_poll
%def_enable hipe
%def_enable megaco_flex_scanner_lineno
%def_with ssl
%def_with ssl_zlib
%def_with java
#Can build jinterface with gcj or Sun java
%def_enable gcj
%def_enable sctp
%def_enable tsp
#Can't build dialyzer with --enable-elib-malloc
%def_disable elib_malloc
%def_enable fixalloc
#Can't enable next 2 parameters :(
%def_enable clock_gettime
%def_enable hybrid_heap
%def_disable lock_checking
%def_without perfctr
%def_with gmp

%def_without minimal_src
#----------------------------------------------------------------------
%define set_disable() %{expand:%%force_disable %{1}} %{expand:%%undefine _enable_%{1}}
%define subst_enable_to() %{expand:%%{?_enable_%{1}:--enable-%{2}}} %{expand:%%{?_disable_%{1}:--disable-%{2}}}
%define subst_with_to() %{expand:%%{?_with_%{1}:--with-%{2}}} %{expand:%%{?_without_%{1}:--without-%{2}}}
%{?_enable_smp_io_thread:%set_disable port_tasks}

%define Name Erlang
Name: erlang
%define ver R12B
%define subver 0
Version: %ver.%subver
Release: alt0
Summary: A programming language developed by Ericsson
License: EPL
Group: Development/Other
URL: http://www.%name.org
Source: otp%{?_with_minimal_src:_minimal}_src_%ver-%subver.tar.gz
Patch0: otp-R11B-5-odbcserver.patch
Patch1: otp-rpath.patch
Patch2: otp-sslrpath.patch
Patch3: otp_src_R12B-0-osp1.patch

Packager: Mikhail Yakshin <greycat@altlinux.org>

# Automatically added by buildreq on Tue Jun 05 2007 (-bi)
#BuildRequires: flex java-devel libgmp-devel libncurses-devel libssl-devel libunixODBC-devel openssl symlinks tcl

BuildRequires: gcc-c++ flex libncurses-devel libunixODBC-devel symlinks
BuildRequires: zlib-devel sh libgd2-devel
%if_with java
%if_enabled gcj
BuildRequires: jdkgcj
%else
BuildRequires: /proc java-devel
%endif
%endif
%{?_with_ssl:BuildRequires: libssl-devel openssl}
%{?_with_gmp:BuildRequires: libgmp-devel}

%description
%Name is a programming language developed at Ericsson Computer Science
Laboratory. %Name provides many features which are more commonly
associated with an operating system: concurrent processes, scheduling,
memory management, distribution, networking, etc.


%package megaco
Summary: H.248 support for %Name
Group: Development/Other
Requires: %name = %version-%release

%description megaco
Megaco (aka H.248) is a signalling protocol used in VoIP networks.
This package adds support for Megaco to your %Name installation.


%package visual
Summary: Standart visual applications for %Name
Group: Development/Other
Requires: %name = %version-%release
Requires: tk

%description visual
Standard visual applications for %Name programming language.


%package odbc
Summary: ODBC support for %Name
Group: Development/Other
Requires: %name = %version-%release

%description odbc
ODBC support for %Name programming language.


%package docbuilder
Summary: Tool for generating HTML documentation for %Name applications
Group: Development/Other
Requires: %name = %version-%release

%description docbuilder
Tool for generating HTML documentation for %Name applications.


%prep
%setup -n otp_src_%ver-%subver
chmod -R u+w ./
%patch3 -p1
#patch0 -p1
%patch1 -p1
%patch2 -p1


%build
%define _optlevel 3
%add_optflags -fno-stack-protector
export CFLAGS="%optflags"
export LIBS="-lcrypto -lgd"
%undefine __libtoolize
%define _configure_script ./otp_build configure
%configure \
    --libdir=%_libexecdir \
    %{subst_enable threads} \
    %{subst_enable_to smp smp-support} \
    %{subst_enable kernel_poll kernel-poll} \
    %{subst_enable hipe} \
    %{subst_enable_to megaco_flex_scanner_lineno megaco-flex-scanner-lineno} \
    %{subst_with ssl} \
    %{subst_with_to ssl_zlib ssl-zlib} \
    %{subst_with gmp} \
    %{subst_enable sctp} \
    %{subst_enable tsp} \
    %{subst_enable fixalloc} \
    %{subst_enable_to elib_malloc elib-malloc} \
    %{subst_enable_to hybrid_heap hybrid-heap} \
    %{subst_enable_to lock_checking lock-checking} \
    %{subst_enable_to clock_gettime clock-gettime} \
    --disable-erlang-mandir

%make TARGET=%_target_platform%_gnu


%install
%make_install TARGET=%_target_platform%_gnu INSTALL_PREFIX=%buildroot install

for l in %buildroot%_libexecdir/%name/lib/*; do
    if [ -d $l/src ]; then
	H=$(find $l/src -type f -name '*.hrl' | grep -v '.*_internal\.hrl$') ||:
	if [ -n "$H" ]; then
	    install -d -m 0755 $l/include/
	    mv $H $l/include/
	    for f in $H; do
		ln -sf $l/include/$(basename $f) $f
	    done
	    find $l/src/* -not -type l -delete
	else
	    rm -rf $l/src
	fi
    fi
done
rm -rf %buildroot%_libexecdir/%name/{lib/*/c_src,erts-*/src}
find %buildroot -empty -delete

install -d -m 0755 %buildroot%_docdir/%name-%version
install -m 0644 AUTHORS EPLICENCE %buildroot%_docdir/%name-%version/

symlinks -cdr %buildroot
symlinks -scdr %buildroot

install -d -m 0755 %buildroot%_sysconfdir/rpm/macros.d
cat > %buildroot%_sysconfdir/rpm/macros.d/%name <<__MACROS__
%%_otpdir %%_libexecdir/erlang
%%_erldir %%_otpdir
%%_otplibdir %%_otpdir/lib
%%_erllibdir %%_otplibdir
%%_otpmandir %%_otpdir/man
%%_erlmandir %%_otpmandir
__MACROS__

rm -rf %buildroot%_libexecdir/%name/{Install,misc,usr/lib}

subst 's|%buildroot||' %buildroot%_libexecdir/%name/{{,erts-*/}bin/{erl,start},releases/RELEASES}

%add_findreq_skiplist /usr/lib/erlang/lib/megaco-*/examples/meas/*.sh.skel


%files
%dir %_docdir/%name-%version
%_docdir/%name-%version/*
%_bindir/*
%_sysconfdir/rpm/macros.d/*
%dir %_libexecdir/%name
%dir %_libexecdir/%name/bin
%_libexecdir/%name/bin/*
%_libexecdir/%name/erts-*
%_libexecdir/%name/releases
%_libexecdir/%name/usr
%dir %_libexecdir/%name/lib
%_libexecdir/%name/lib/asn1-*
%_libexecdir/%name/lib/common_test-*
%_libexecdir/%name/lib/compiler-*
%_libexecdir/%name/lib/cosEvent-*
%_libexecdir/%name/lib/cosEventDomain-*
%_libexecdir/%name/lib/cosFileTransfer-*
%_libexecdir/%name/lib/cosNotification-*
%_libexecdir/%name/lib/cosProperty-*
%_libexecdir/%name/lib/cosTime-*
%_libexecdir/%name/lib/cosTransactions-*
%_libexecdir/%name/lib/crypto-*
%_libexecdir/%name/lib/dialyzer-*
%_libexecdir/%name/lib/edoc-*
%_libexecdir/%name/lib/erl_interface-*
%_libexecdir/%name/lib/hipe-*
%_libexecdir/%name/lib/ic-*
%_libexecdir/%name/lib/inets-*
%_libexecdir/%name/lib/inviso-*
%_libexecdir/%name/lib/jinterface-*
%_libexecdir/%name/lib/kernel-*
#_libexecdir/%name/lib/mnemosyne-*
%_libexecdir/%name/lib/mnesia-*
#_libexecdir/%name/lib/mnesia_session-*
%_libexecdir/%name/lib/observer-*
%_libexecdir/%name/lib/orber-*
%_libexecdir/%name/lib/os_mon-*
%_libexecdir/%name/lib/otp_mibs-*
%_libexecdir/%name/lib/parsetools-*
%_libexecdir/%name/lib/percept-*
%_libexecdir/%name/lib/runtime_tools-*
%_libexecdir/%name/lib/sasl-*
%_libexecdir/%name/lib/snmp-*
%_libexecdir/%name/lib/ssh-*
%_libexecdir/%name/lib/ssl-*
%_libexecdir/%name/lib/stdlib-*
%_libexecdir/%name/lib/syntax_tools-*
%_libexecdir/%name/lib/test_server-*
%_libexecdir/%name/lib/tools-*
%_libexecdir/%name/lib/typer-*
%_libexecdir/%name/lib/webtool-*
%_libexecdir/%name/lib/xmerl-*


%files megaco
%_libexecdir/%name/lib/megaco-*


%files visual
%_libexecdir/%name/lib/appmon-*
%_libexecdir/%name/lib/debugger-*
%_libexecdir/%name/lib/et-*
%_libexecdir/%name/lib/gs-*
%_libexecdir/%name/lib/pman-*
%_libexecdir/%name/lib/toolbar-*
%_libexecdir/%name/lib/tv-*


%files odbc
%_libexecdir/%name/lib/odbc-*


%files docbuilder
%_libexecdir/%name/lib/docbuilder-*


%changelog
* Sun Dec 09 2007 Damir Shayhutdinov <damir@altlinux.ru> R12B.0-alt0
- new release

* Sun Nov 11 2007 Mikhail Yakshin <greycat@altlinux.org> R11B.5-alt1
- tested with ejabberd and built for Sisyphus

* Tue Oct 09 2007 Led <led@altlinux.ru> R11B.5-alt0.9
- cleaned up and fixed spec
- fixed BuildRequires

* Mon Sep 10 2007 Led <led@altlinux.ru> R11B.5-alt0.8
- added new rpm macros

* Fri Sep 07 2007 Led <led@altlinux.ru> R11B.5-alt0.7
- reverted non-internal headers to %_libexecdir/%name/lib/*/ as symlinks

* Thu Sep 06 2007 Led <led@altlinux.ru> R11B.5-alt0.6
- added additional *.hrl files

* Wed Sep 05 2007 Led <led@altlinux.ru> R11B.5-alt0.5
- cleaned up sources in packages

* Tue Aug 28 2007 Led <led@altlinux.ru> R11B.5-alt0.4
- added rpm macros

* Mon Aug 27 2007 Led <led@altlinux.ru> R11B.5-alt0.3
- moved libs from %%_libdir to %%_libexecdir

* Fri Aug 17 2007 Led <led@altlinux.ru> R11B.5-alt0.2
- added otp-R11B-5-odbcserver.patch (fixed #12576)

* Tue Jun 26 2007 Led <led@altlinux.ru> R11B.5-alt0.1
- R11B-5
- added %name-docbuilder subpackage

* Tue Jun 05 2007 Led <led@altlinux.ru> R11B.4-alt0.1
- R11B-4
- cleaned up spec
- removed docs
- removed emacs-mode-%name
- added patches from FC7
- used gcj

* Tue Feb 20 2007 Mikhail Yakshin <greycat@altlinux.ru> R11B-alt2
- Fixed x86_64 build

* Sat Feb 10 2007 Mikhail Yakshin <greycat@altlinux.org> R11B-alt1
- R11B-3

* Fri Dec 29 2006 ALT QA Team Robot <qa-robot@altlinux.org> R10B.10-alt2.1
- Rebuilt due to libcrypto.so.4 -> libcrypto.so.6 soname change.

* Thu Oct 12 2006 Alex V. Myltsev <avm@altlinux.ru> R10B.10-alt2
- Merged with alb's version from backports.
- Applied the 'new glibc' patch.
- Moved zlib.3.gz to erl_zlib.3.gz.
- Moved Megaco to a separate package..

* Thu Sep 07 2006 Alexey Borovskoy <alb@altlinux.ru> R11B.1-alt0.M24.1
- New release (R11B-1).

* Wed Mar 22 2006 Alexey Borovskoy <alb@altlinux.ru> R10B.10-alt0.M24.1
- New release (R10B-10).

* Mon Dec 19 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.9-alt0.M24.1
- New release (R10B-9).

* Sun Oct 30 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.8-alt0.M24.2
- Add ODBC support.

* Fri Oct 28 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.8-alt0.M24.1
- New release (R10B-8).
- Add patch for disable static linking with zlib. Does not work and disabled.
- Add zlib-devel buildtime dependency. But dymamic linking with zlib not
  supported in erts/emulator/dirvers/common/gzio.c due using private zutil.h.
- Remove --enable-threads due erl segfault.

* Thu Sep 08 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.7-alt0.M24.1
- New release (R10B-7)

* Wed Aug 10 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.6-alt0.M24.1
- New release (R10B-6)

* Wed May 11 2005 Alexey Borovskoy <alb@altlinux.ru> R10B.4-alt0.M24.1
- New release (R10B-4)
- Split to subpackages:
  + manual
    For manual in HTML
  + manpages
    For manpages
  + visual
    For visual apps that requires tk/tcl
  + emacs-mode-erlang
    For Emacs mode

* Tue Nov 02 2004 Plugnikov A. Mike <amike@altlinux.ru> R10B.0-alt1
- New version (R10B)
- Merged upstream patches:
  patch-lib_stdlib_src_dets__v9
  erlang_ssl_broker
- Fix spec

* Sat May 15 2004 Ott Alex <ott@altlinux.ru> R9C.0-alt3
- Fix build process

* Sun Feb 22 2004 Ott Alex <ott@altlinux.ru> R9C.0-alt2
- Added some fixes from freebsd ports (thanks to Ermine!)
- Build without tcl/tk & java

* Wed Dec 10 2003 Ott Alex <ott@altlinux.ru> R9C.0-alt1
- Initial build for ALTLinux
